/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package quail;

import java.math.BigDecimal;
import java.util.HashMap;
import java.util.Set;

/**
 *
 * @author fbio
 */
class ConcurrentSimpleProbabilityDistribution extends HashMap<String,BigDecimal> implements ProbabilityDistribution{
    protected static final Contexter contexter = Contexter.getInstance();
    protected static final Logger logger = Logger.getInstance();
    /*@Override
    public BigDecimal getLaplaceProbability(String key) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }*/

    synchronized void addProbability(String key, BigDecimal stateprob) {
     
            if (!this.containsKey(key)){
                this.put(key, stateprob);
            }else{
                this.put(key, stateprob.add(this.get(key), contexter.getContext()));
            }
       
    }
    
    
    @Override
    public BigDecimal getProbability(String key) {
        return this.get(key);
    }

    @Override
    public BigDecimal getEntropy() {
        BigDecimal entropy = new BigDecimal(0,contexter.getContext());
        Set<String> keys = this.keySet();
        for (String key : keys){
            BigDecimal prob = this.getProbability(key);
            BigDecimal localent = prob.multiply(log2(prob), contexter.getContext());
            log("Local entropy: "+localent,4);
            entropy = entropy.subtract(localent, contexter.getContext());
        }
        
        return entropy;
    }
    protected static void log(Object aObject, int level){
        logger.log(String.valueOf(aObject),level);
    }

    
    protected BigDecimal log2(BigDecimal value) {
        if (value.compareTo(contexter.getDecimalOne())==0){
            return contexter.getDecimalZero();
        }
        log("Computing the logarithm in base 2 of "+value.toPlainString()+" with scale "+value.scale(),4);
        BigDecimal toreturn = BigFunctions.ln(value,contexter.getContext().getPrecision()+10);
        log("The natural logarithm is "+toreturn,4);
        toreturn = toreturn.divide(BigFunctions.ln(new BigDecimal("2",contexter.getContext()),contexter.getContext().getPrecision()),contexter.getContext());
        log("The logarithm in base 2 is "+toreturn,4);
        
        return toreturn;
    }

    @Override
    public String printNice() {
        String toreturn = "";
        Set<String> keys = this.keySet();
        for (String key : keys){
            toreturn += key+" with probability "+this.getProbability(key).toPlainString()+"\n";
        }
        return toreturn;
    }

    

    BigDecimal getTotalProbability() {
        BigDecimal toreturn = contexter.getDecimalZero();
        Set<String> keys = this.keySet();
        for (String key : keys){
            toreturn = toreturn.add(this.getProbability(key), contexter.getContext());
        }
        log("The total probability for the distribution is "+toreturn.toPlainString(),4);
        return toreturn;
    }
    
    
}
