/*  QUAIL is a tool to evaluate the security of systems through a quantitative analysis of information leakage.
    Copyright (C) 2012 - INRIA Rennes (FR) and IT University of Copenhagen (DK)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
    Author: Fabrizio Biondi <fabrizio.biondi@inria.fr>
*/
    
package quail;

import java.util.ArrayList;

/**
 *
 * @author fbio
 */
class EdgeList extends ArrayList<Edge> {
    
    
    public EdgeList getEdgesFrom(Node v) {
        int mysize = this.size();
        //log("Requested edges from "+v+" among "+mysize+" edges");
        EdgeList toreturn = new EdgeList();
        for (int i=0; i<mysize; i++){
            Edge edge =this.get(i);
            //log("Checking edge "+edge);
            if (edge.getFrom().equals(v.getElement())){
          //      log("Found edge "+edge);
                toreturn.add(edge);
            }
        }
        //log("Edges from "+v+": "+toreturn);
        return toreturn;
    }
    
    private static void log(Object aObject, int level){
        Logger logger = Logger.getInstance();
        logger.log(String.valueOf(aObject),level);
    }
}
