/*  QUAIL is a tool to evaluate the security of systems through a quantitative analysis of information leakage.
    Copyright (C) 2012 - INRIA Rennes (FR) and IT University of Copenhagen (DK)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
    Author: Fabrizio Biondi <fabrizio.biondi@inria.fr>
*/
    
package quail;

/**
 *
 * @author fbio
 */
public class Logger {
    
    private static Logger instance;
    private static int verbosity;
    
    private Logger(){
        verbosity = 2;
    }
    
    public static Logger getInstance(){
        if (instance == null){
            instance = new Logger();
        }
        return instance;
    }
    
    public void setVerbosity(int verb){
        verbosity = verb;
    }
    
    public int getVerbosity(){
        return verbosity;
    }
    
    public void log(String message, int level){
        if (level<=verbosity){
            System.out.println(message);
        }
    }
}
