/*  QUAIL is a tool to evaluate the security of systems through a quantitative analysis of information leakage.
    Copyright (C) 2012 - INRIA Rennes (FR) and IT University of Copenhagen (DK)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
    Author: Fabrizio Biondi <fabrizio.biondi@inria.fr>
*/
    
package quail;


import java.math.BigInteger;


/**
 *
 * @author fbio
 */
public class MarkovStatePublicVariable extends MarkovStateVariable{
    BigInteger val = BigInteger.ZERO;
    boolean observable = false;

    public MarkovStatePublicVariable(String name, BigInteger val, Integer length) {
        super(name, false, length);
        this.val = val;
    }

    public BigInteger getVal() {
        return val;
    }

    public void setVal(BigInteger val) {
        this.val = val;
    }
    
    

    public boolean isObservable() {
        return observable;
    }

    public void setObservable(boolean observable) {
        this.observable = observable;
    }
    

    @Override
    public String toString(){
        String toreturn;
        /*if (observable) {
            toreturn = this.getName().toUpperCase();
        }else{
            toreturn = this.getName().toLowerCase();
        }
        toreturn = toreturn + "="+this.val;*/
        toreturn = this.getName() + "="+this.val;
        return toreturn;
    }

    
    
}
