/*  QUAIL is a tool to evaluate the security of systems through a quantitative analysis of information leakage.
    Copyright (C) 2012 - INRIA Rennes (FR) and IT University of Copenhagen (DK)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
    Author: Fabrizio Biondi <fabrizio.biondi@inria.fr>
*/
    
package quail;

/**
 *
 * @author fbio
 */
public class Node implements Comparable{
    int index;
    int lowlink;
    String element;

    public String getElement() {
        return element;
    }

    public void setElement(String element) {
        this.element = element;
    }

    public int getIndex() {
        return index;
    }

    public void setIndex(int index) {
        this.index = index;
    }

    public int getLowlink() {
        return lowlink;
    }

    public void setLowlink(int lowlink) {
        this.lowlink = lowlink;
    }
    
    public Node(String element) {
        this.element = element;
        this.index = -1;
        this.lowlink = -1;
    }
    
    
    
    @Override
    public String toString(){
        //return "("+this.element+","+this.index+","+this.lowlink+")";
        return this.element;
    }
    
    public String printAll(){
        return "("+this.element+","+this.index+","+this.lowlink+")";
    }

  
    @Override
    public int compareTo(Object o) {
        if (o.getClass()==this.getClass()){
            Node x =(Node)o;
            if (x.getElement().equals(this.element)) {
                return 0;
            }
        }
        return 1;
    }
}
