/*  QUAIL is a tool to evaluate the security of systems through a quantitative analysis of information leakage.
    Copyright (C) 2012 - INRIA Rennes (FR) and IT University of Copenhagen (DK)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
    Author: Fabrizio Biondi <fabrizio.biondi@inria.fr>
*/
    
package quail;


import java.math.BigDecimal;


/**
 *
 * @author Sorti
 */
public class Transition {
    private String source;
    private String dest;
    private BigDecimal value;
    

    public Transition(String source, String dest, BigDecimal val) {
        this.source = source;
        this.dest = dest;
        this.value = val;
        
    }
    
    
    
    public BigDecimal getValue() {
        return value;
    }

    public void setValue(BigDecimal val) {
        this.value = val;
    }

    public String getDest() {
        return dest;
    }

    public void setDest(String dest) {
        this.dest = dest;
    }

    public String getSource() {
        return source;
    }

    public void setSource(String source) {
        this.source = source;
    }

    @Override
    public String toString(){
        String s = source+" -> "+dest+" : "+value;
        return s;
    }
}
